SystemOrganization addCategory: #PreferenceBrowser!

RectangleMorph subclass: #UpdatingRectangleMorph
	instanceVariableNames: 'target lastValue getSelector putSelector contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PreferenceBrowser'!

!UpdatingRectangleMorph commentStamp: '<historical>' prior: 0!
Intended for use as a color swatch coupled to a color obtained from the target, but made just slightly more general than that.!

!UpdatingRectangleMorph methodsFor: 'accessing' stamp: 'sw 9/4/97 21:43'!
contents
	^ contents! !

!UpdatingRectangleMorph methodsFor: 'accessing' stamp: 'sw 9/4/97 21:43'!
contents: c
	contents := c! !

!UpdatingRectangleMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:35'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	^ Color lightGray lighter! !

!UpdatingRectangleMorph methodsFor: 'accessing' stamp: 'sw 1/6/2005 16:31'!
getSelector
	"Answer the getSelector"

	^ getSelector! !

!UpdatingRectangleMorph methodsFor: 'accessing' stamp: ''!
getSelector: aSymbol

	getSelector := aSymbol.
! !

!UpdatingRectangleMorph methodsFor: 'event handling' stamp: 'dgd 2/22/2003 18:45'!
handlesMouseDown: evt 
	^putSelector notNil! !

!UpdatingRectangleMorph methodsFor: 'event handling' stamp: 'ar 10/5/2000 18:54'!
mouseUp: evt

	self changeColorTarget: self selector: #setTargetColor: originalColor: color hand: evt hand.! !

!UpdatingRectangleMorph methodsFor: 'accessing' stamp: 'sw 10/30/97 00:55'!
putSelector
	^ putSelector! !

!UpdatingRectangleMorph methodsFor: 'accessing' stamp: 'sw 10/30/97 00:55'!
putSelector: aSymbol
	putSelector := aSymbol! !

!UpdatingRectangleMorph methodsFor: 'target access' stamp: 'dgd 2/22/2003 14:40'!
readFromTarget
	"Read the color value from my target"

	| v |
	(target isNil or: [getSelector isNil]) ifTrue: [^contents].
	target isMorph ifTrue: [target isInWorld ifFalse: [^contents]].
	v := self valueProvider perform: getSelector.
	lastValue := v.
	^v! !

!UpdatingRectangleMorph methodsFor: 'setting' stamp: 'sw 3/23/2001 23:26'!
setTargetColor: aColor
	"Set my target's color as indicated"

	putSelector ifNotNil:
		[self color: aColor.
		contents := aColor.
		self valueProvider perform: self putSelector withArguments: (Array with: aColor)]
! !

!UpdatingRectangleMorph methodsFor: 'stepping and presenter' stamp: 'sw 7/15/1999 07:27'!
step
	| s |
	super step.
	s := self readFromTarget.
	s = contents ifFalse:
		[self contents: s.
		self color: s]
! !

!UpdatingRectangleMorph methodsFor: 'testing' stamp: ''!
stepTime

	^ 50! !

!UpdatingRectangleMorph methodsFor: 'accessing' stamp: ''!
target

	^ target
! !

!UpdatingRectangleMorph methodsFor: 'accessing' stamp: ''!
target: anObject

	target := anObject.
! !

!UpdatingRectangleMorph methodsFor: 'accessing' stamp: 'sw 11/15/2001 16:22'!
userEditsAllowed
	"Answer whether it is suitable for a user to change the value represented by this readout"

	^ putSelector notNil! !

!UpdatingRectangleMorph methodsFor: 'setting' stamp: 'HenrikSperreJohansen 9/10/2009 15:07'!
valueProvider
	"Answer the object to which my get/set messages should be sent.  This is inefficient and contorted in order to support grandfathered content for an earlier design"

	^ target ! !

!UpdatingRectangleMorph methodsFor: 'copying' stamp: 'tk 1/7/1999 17:17'!
veryDeepFixupWith: deepCopier
	"If target and arguments fields were weakly copied, fix them here.  If they were in the tree being copied, fix them up, otherwise point to the originals!!!!"

super veryDeepFixupWith: deepCopier.
target := deepCopier references at: target ifAbsent: [target].! !

!UpdatingRectangleMorph methodsFor: 'copying' stamp: 'tk 1/7/1999 17:17'!
veryDeepInner: deepCopier
	"Copy all of my instance variables.  Some need to be not copied at all, but shared.  	Warning!!!!  Every instance variable defined in this class must be handled.  We must also implement veryDeepFixupWith:.  See DeepCopier class comment."

super veryDeepInner: deepCopier.
"target := target.		Weakly copied"
lastValue := lastValue veryDeepCopyWith: deepCopier.
"getSelector := getSelector.		a Symbol"
"putSelector := putSelector.		a Symbol"
contents := contents veryDeepCopyWith: deepCopier.! !

Morph subclass: #PBPreferenceButtonMorph
	instanceVariableNames: 'moreButton model preference preferenceMorphicView preferenceView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PreferenceBrowser'!

!PBPreferenceButtonMorph classSide methodsFor: 'instance creation' stamp: 'hpt 12/8/2004 15:20'!
preference: aPreference
	^self preference: aPreference model: nil! !

!PBPreferenceButtonMorph classSide methodsFor: 'instance creation' stamp: 'hpt 12/8/2004 15:19'!
preference: aPreference model: aModel
	^self new
		initializeWithPreference: aPreference model: aModel;
		yourself.! !

!PBPreferenceButtonMorph methodsFor: 'extra controls' stamp: 'hpt 12/8/2004 18:15'!
actionButtons
	^self preferenceView actions collect: [:aTuple |
		self basicButton
				label: aTuple first;
				target: aTuple second;
				actionSelector: aTuple third;
				arguments: aTuple fourth;
				setBalloonText: aTuple fifth ]! !

!PBPreferenceButtonMorph methodsFor: 'extra controls' stamp: 'hpt 8/24/2005 20:33'!
addExtraControls
	| m |
	m := self horizontalPanel
		cellInset: 3;
		addAllMorphs: self actionButtons;
		addMorphBack: self horizontalFiller;
		addMorphBack: self moreButton;
		yourself.
	self 
		addMorphBack: (self blankSpaceOf: 2@2);
		addMorphBack: self preferenceHelpTextMorph;
		fullBounds; "to force a layout compute needed by the textMorphs's autoFit"
		addMorphBack: m
! !

!PBPreferenceButtonMorph methodsFor: 'extra controls' stamp: 'hpt 12/8/2004 17:16'!
advancedOptionsSelected
	self preferenceView offerPreferenceNameMenu: self model! !

!PBPreferenceButtonMorph methodsFor: 'utility methods' stamp: 'hpt 12/8/2004 17:06'!
basicButton
	| button |
	button := SimpleButtonMorph new.
	button
		borderWidth: 1;
		borderColor: self paneColor;
		on: #mouseEnter send: #value to: [button borderWidth: 2];
		on: #mouseLeave send: #value to: [button borderWidth: 1];
		vResizing: #rigid;
		height: (TextStyle defaultFont height + 4);
		useSquareCorners;
		clipSubmorphs: true;
		color: self paneColor muchLighter;
		target: self.
	^button! !

!PBPreferenceButtonMorph methodsFor: 'utility methods' stamp: 'hpt 12/8/2004 15:59'!
basicPanel
	^BorderedMorph new
		beTransparent;
		extent: 0@0;
		borderWidth: 0;
		layoutInset: 0;
		cellInset: 0;
		layoutPolicy: TableLayout new;
		listCentering: #topLeft;
		cellPositioning: #center;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		yourself! !

!PBPreferenceButtonMorph methodsFor: 'utility methods' stamp: 'hpt 12/8/2004 15:29'!
blankSpaceOf: aPoint
	^Morph new 
		beTransparent;
		extent: aPoint; 
		yourself! !

!PBPreferenceButtonMorph methodsFor: 'utility methods' stamp: 'hpt 12/8/2004 15:43'!
caseInsensitiveBeginsWith: prefix in: string
	^(string findString: prefix startingAt: 1 caseSensitive: false) = 1! !

!PBPreferenceButtonMorph methodsFor: 'highlighting' stamp: 'hpt 12/8/2004 15:55'!
highlightOff
	self beTransparent.
	self label color: Color black.
	self removeExtraControls.! !

!PBPreferenceButtonMorph methodsFor: 'highlighting' stamp: 'hpt 12/8/2004 17:25'!
highlightOn
	self color: (Color gray alpha: 0.1).
	self label color: Color red.
	self addExtraControls.! !

!PBPreferenceButtonMorph methodsFor: 'utility methods' stamp: 'hpt 12/8/2004 16:42'!
horizontalFiller
	^self horizontalPanel
		hResizing: #spaceFill;
		yourself.! !

!PBPreferenceButtonMorph methodsFor: 'utility methods' stamp: 'hpt 12/8/2004 16:42'!
horizontalPanel
	^self basicPanel
		cellPositioning: #center;
		listDirection: #leftToRight;
		yourself.! !

!PBPreferenceButtonMorph methodsFor: 'initialization' stamp: 'hpt 12/8/2004 15:38'!
initializeLayout
	self layoutPolicy: TableLayout new;
		beTransparent;
		layoutInset: 0;
		cellInset: 0;
		listCentering: #topLeft;
		cellPositioning: #topLeft;
		listDirection: #topToBottom;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap.		! !

!PBPreferenceButtonMorph methodsFor: 'initialization' stamp: 'hpt 12/8/2004 15:38'!
initializeWithPreference: aPreference model: aModel
	preference := aPreference.
	model := aModel.
	self initializeLayout.
	self addMorphBack: self preferenceMorphicView.
	self highlightOff.! !

!PBPreferenceButtonMorph methodsFor: 'preference accessing' stamp: 'hpt 12/8/2004 15:42'!
label
	^self preferenceMorphicView firstSubmorph! !

!PBPreferenceButtonMorph methodsFor: 'accessing' stamp: 'hpt 12/8/2004 15:34'!
model
	^model! !

!PBPreferenceButtonMorph methodsFor: 'extra controls' stamp: 'hpt 12/8/2004 18:17'!
moreButton
	^moreButton ifNil: 
		[moreButton := self basicButton 
						label: 'more' translated; 
						setBalloonText: 
							'Click here for advanced options'translated;
						actionSelector: #advancedOptionsSelected]! !

!PBPreferenceButtonMorph methodsFor: 'utility methods' stamp: 'stephaneducasse 2/4/2006 20:39'!
paneColor
	| browser |
	browser := (self ownerChain 
		detect: [:ea | ea isKindOf: PreferenceBrowserMorph] 
		ifNone: [^Color black]) .
	^browser paneColor! !

!PBPreferenceButtonMorph methodsFor: 'preference accessing' stamp: 'hpt 12/8/2004 15:13'!
preference
	^preference! !

!PBPreferenceButtonMorph methodsFor: 'preference accessing' stamp: 'hpt 12/8/2004 15:56'!
preferenceHelp
	| help name |
	help := self preference helpString withBlanksTrimmed.
	name := self preference name.
	(self caseInsensitiveBeginsWith: name  in: help)
		ifTrue: [help := help allButFirst: name size].
	(help notEmpty and: [help first = $:])
		ifTrue: [help := help allButFirst].
	^help withBlanksTrimmed.
! !

!PBPreferenceButtonMorph methodsFor: 'preference accessing' stamp: 'hpt 12/8/2004 15:25'!
preferenceHelpText
	^self preferenceHelp asText
		addAttribute: TextEmphasis italic;
		yourself.! !

!PBPreferenceButtonMorph methodsFor: 'extra controls' stamp: 'stephaneducasse 2/4/2006 20:39'!
preferenceHelpTextMorph
	| text tm |
	text := self preferenceHelpText.
	tm := TextMorph new
		contents: text;
		wrapOnOff;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		lock: true;
		visible: text notEmpty;
		yourself. "we don't want an empty textmorph showing"
	tm isAutoFit
		ifFalse: [tm autoFitOnOff].
	^tm.! !

!PBPreferenceButtonMorph methodsFor: 'preference accessing' stamp: 'AlainPlantec 12/11/2009 06:55'!
preferenceMorphicView
	^ preferenceMorphicView
		ifNil: [preferenceMorphicView := self preferenceView
						representativeButtonWithColor: (preference isMigratedToSetting
								ifTrue: [Color green muchLighter]
								ifFalse: [preference isNotMigratedToSetting
										ifTrue: [Color red muchLighter]
										ifFalse: [preference isSemiMigratedToSetting
										ifTrue: [Color blue muchLighter]
										ifFalse: [preference isObsolete
										ifTrue: [Color gray muchLighter]
										ifFalse: [Color transparent]]]])
						inPanel: self model. 
			preferenceMorphicView hResizing: #spaceFill.
			^ preferenceMorphicView]! !

!PBPreferenceButtonMorph methodsFor: 'preference accessing' stamp: 'stephaneducasse 2/4/2006 20:39'!
preferenceView
	^preferenceView
		ifNil: [preferenceView := self preference viewForPanel: self model.]! !

!PBPreferenceButtonMorph methodsFor: 'extra controls' stamp: 'hpt 12/8/2004 16:40'!
removeExtraControls
	self submorphs copyWithoutFirst do: [:ea | ea delete]! !

!PBPreferenceButtonMorph methodsFor: 'utility methods' stamp: 'hpt 12/8/2004 15:27'!
verticalPanel
	^self basicPanel
		cellPositioning: #topLeft;
		listDirection: #topToBottom;
		yourself.! !

Model subclass: #PreferenceBrowser
	instanceVariableNames: 'selectedCategoryIndex selectedPreference searchPattern searchResults lastExecutedSearch preferences title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PreferenceBrowser'!

!PreferenceBrowser classSide methodsFor: 'initialization' stamp: 'AlainPlantec 10/17/2009 18:14'!
initialize
	self
		registerWindowColor;
		registerInOpenMenu! !

!PreferenceBrowser classSide methodsFor: 'instance creation' stamp: 'stephaneducasse 2/4/2006 20:39'!
open
	| browser |
	browser := self new.
	(PreferenceBrowserMorph withModel: browser)
		openInWorld.
	^browser.	! !

!PreferenceBrowser classSide methodsFor: 'initialization' stamp: 'hpt 9/19/2004 12:40'!
registerInOpenMenu
	(TheWorldMenu respondsTo: #registerOpenCommand:) ifTrue: [
		TheWorldMenu unregisterOpenCommand: 'Preference Browser'.
		TheWorldMenu registerOpenCommand: {'Preference Browser'. {self. #open}}].
		! !

!PreferenceBrowser classSide methodsFor: 'initialization' stamp: 'hpt 9/19/2004 12:39'!
registerWindowColor
	(Preferences windowColorFor: self name) = Color white
		ifTrue: [ Preferences setWindowColorFor: self name to: (Color colorFrom: self windowColorSpecification brightColor) ].! !

!PreferenceBrowser classSide methodsFor: 'initialization' stamp: 'AlainPlantec 10/17/2009 16:44'!
unload
	self 
		unregisterFromOpenMenu! !

!PreferenceBrowser classSide methodsFor: 'initialization' stamp: 'hpt 9/19/2004 12:44'!
unregisterFromOpenMenu
	 (TheWorldMenu respondsTo: #registerOpenCommand:)
		ifTrue: [TheWorldMenu unregisterOpenCommand: 'Preference Browser'].
! !

!PreferenceBrowser classSide methodsFor: 'window color' stamp: 'hpt 9/18/2004 15:46'!
windowColorSpecification
	"Answer a WindowColorSpec object that declares my preference"

	^ WindowColorSpec classSymbol: self name wording: 'Preference Browser' brightColor: #(0.645 1.0 1.0)	pastelColor: #(0.886 1.0 1.0) helpMessage: 'A tool for expressing personal preferences for numerous options.'! !

!PreferenceBrowser methodsFor: 'user interface' stamp: 'hpt 9/19/2004 02:30'!
allCategoryLabel
	^'-- all --' translated! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 17:59'!
allCategorySelected
	^self selectedCategory = self allCategoryLabel! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'rr 10/1/2005 15:05'!
allPreferences
	^ preferences allPreferenceObjects  asSortedCollection:
			[:pref1 :pref2 | 
			pref1 viewRegistry viewOrder  <pref2 viewRegistry viewOrder  or:
					[pref1 viewRegistry viewOrder  =pref2 viewRegistry viewOrder 
						 &(pref1 name  <pref2 name)]]! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'rr 10/1/2005 15:05'!
categoryList
	^OrderedCollection new
		add:  self allCategoryLabel;
		addAll: preferences categoryNames asSortedCollection;
		add: self searchResultsCategoryLabel;
		yourself.
	
	! !

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'hpt 9/19/2004 12:01'!
defaultSelected
	Preferences chooseInitialSettings! !

!PreferenceBrowser methodsFor: 'find' stamp: 'rr 10/1/2005 15:05'!
findCategoryFromPreference: prefSymbol
	"Find all categories in which the preference occurs"

	| aMenu| 
	aMenu := MenuMorph new defaultTarget: self.
	(preferences categoriesContainingPreference: prefSymbol) do:
		[:aCategory | aMenu add: aCategory target: self selector: #selectedCategory: argument: aCategory].
	aMenu popUpInWorld! !

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'hpt 8/27/2005 13:18'!
helpSelected 
	"Open up a workspace with explanatory info in it about the Preference Browser"
	Workspace new
		contents: self helpText;
		openLabel: self windowTitle.! !

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'adrian_lienhard 7/18/2009 15:59'!
helpText
	^(String streamContents: [:str |
		str nextPutAll:
'Many aspects of the system are goberned by the settings of various ''Preferences''.

Click on any of the categories shown at the left list to see all the preferences in that category. Or type into the search box at the bottom of the window, then hit Search, and all Preferences matching whatever you typed in will appear in the ''search results'' category. A preference is considered to match your search if either its name matches the text *or* if anything in the preference''s help text does.

To find out more about any particular Preference just select it and its help text will appear.

Some preferences can be ''local'' instead of global. When a preference is set as global its value will apply to whatever project you are in. A local preference will only be valid in the project that you set it in.

The ''Save'' button allow you to quickly save your current settings so it can later be restored with the ''Load'' button.

To carry your settings to another image you might want to use the ''Save to disk'' and ''Load from disk'' buttons. The save to disk option will store all your settings in a ''my.prefs'' file in your Pharo''s current directory.

Lastly, you can use the "theme..." button to set multiple preferences all at once; click on the "theme..." button and try the themes already provided with your Pharo image.']) translated! !

!PreferenceBrowser methodsFor: 'initialization' stamp: 'alain.plantec 5/28/2009 10:15'!
initialize
	super initialize.
	preferences := Preferences.
	title := 'Preference Browser'.! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 8/27/2005 23:35'!
lastExecutedSearch
	^lastExecutedSearch! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'stephaneducasse 2/4/2006 20:39'!
lastExecutedSearch: aTextOrString
	^lastExecutedSearch:= aTextOrString! !

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'rr 10/1/2005 15:05'!
loadFromDiskSelected 
	preferences restorePreferencesFromDisk! !

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'rr 10/1/2005 15:05'!
loadSelected
	preferences restorePersonalPreferences ! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 18:01'!
nonSpecialCategorySelected
	^self allCategorySelected not & self searchResultsCategorySelected not! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'rr 10/11/2005 17:14'!
preferences
	^ preferences! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'rr 10/1/2005 15:05'!
preferencesInCategory: aCategory
	^(preferences preferenceObjectsInCategory: aCategory)! !

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'rr 10/1/2005 15:05'!
saveSelected
	preferences savePersonalPreferences ! !

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'rr 10/1/2005 15:05'!
saveToDiskSelected 
	preferences storePreferencesToDisk! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 7/8/2006 17:50'!
searchFieldLegend
	^''.! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 8/27/2005 23:39'!
searchPattern
	^searchPattern ifNil: [searchPattern := self searchFieldLegend]! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'stephaneducasse 2/4/2006 20:39'!
searchPattern: aStringOrText
	aStringOrText 
		ifEmpty: [searchPattern := self searchFieldLegend]
		ifNotEmpty: [searchPattern := aStringOrText asString].
	self changed: #searchPattern.
	^true! !

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'hpt 8/27/2005 23:36'!
searchPreferencesFor: pattern
	| result |
	result := pattern asString asLowercase withBlanksTrimmed.
	result ifEmpty: [^self].
	searchResults := self allPreferences select: [:aPreference |
		(aPreference name includesSubstring: result caseSensitive: false) or:
				[aPreference helpString includesSubstring: result caseSensitive: false]].		
	self selectSearchResultsCategory.
	self lastExecutedSearch: pattern.
! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'stephaneducasse 2/4/2006 20:39'!
searchResults
	^searchResults ifNil: [searchResults := #()]! !

!PreferenceBrowser methodsFor: 'user interface' stamp: 'hpt 9/19/2004 02:30'!
searchResultsCategoryLabel
	^'-- search results --' translated! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 18:01'!
searchResultsCategorySelected
	^self selectedCategory = self searchResultsCategoryLabel! !

!PreferenceBrowser methodsFor: 'buttons callbacks' stamp: 'hpt 9/19/2004 03:21'!
searchSelected
	self searchPreferencesFor: self searchPattern.! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'stephaneducasse 2/4/2006 20:39'!
selectFirstPreferenceOrNil
	| prefs |
	self selectedCategory
		ifNil: [^self selectedPreference: nil].
	prefs := self preferencesInCategory: self selectedCategory.
	prefs isEmpty
		ifTrue: [^self selectedPreference: nil].
	self selectedPreference: prefs first.! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/19/2004 03:23'!
selectSearchResultsCategory
	self selectedCategoryIndex: (self categoryList indexOf: self searchResultsCategoryLabel)! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/19/2004 00:01'!
selectedCategory
	^self categoryList at: selectedCategoryIndex ifAbsent: []! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/25/2004 17:09'!
selectedCategory: aCategorySymbol
	self selectedCategoryIndex: (self categoryList indexOf: aCategorySymbol ifAbsent: [0]).! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 20:49'!
selectedCategoryIndex
	^selectedCategoryIndex ifNil: [selectedCategoryIndex := 0].! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 23:45'!
selectedCategoryIndex: anIndex
	anIndex = 0
		ifTrue: [^self].
	self selectedPreference: nil.
	selectedCategoryIndex := anIndex.
	self changed: #selectedCategoryIndex.! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/19/2004 03:27'!
selectedCategoryPreferences
	self allCategorySelected
		ifTrue: [^self allPreferences].
	self searchResultsCategorySelected 
		ifTrue: [^self searchResults].
	^self preferencesInCategory: self selectedCategory.
	! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 20:53'!
selectedPreference
	^selectedPreference! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/19/2004 00:39'!
selectedPreference: aPreference
	selectedPreference := aPreference.
	self changed: #selectedPreference.
	self changed: #selectedPreferenceIndex.
	self changed: #selectedPreferenceHelpText.! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 12/8/2004 15:22'!
selectedPreferenceHelpText
	self selectedPreference
		ifNil: [^''].
	^self selectedPreference helpString withBlanksTrimmed.! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 21:17'!
selectedPreferenceIndex
	^self selectedCategoryPreferences indexOf: self selectedPreference ifAbsent: [0]! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 23:41'!
selectedPreferenceIndex: anIndex
	anIndex = 0
		ifTrue: [^self].
	self selectedPreference: (self selectedCategoryPreferences at: anIndex).! !

!PreferenceBrowser methodsFor: 'stepping' stamp: 'hpt 8/27/2005 23:35'!
stepAt: millisecondClockValue in: aWindow
	super stepAt: millisecondClockValue in: aWindow.
	self searchPattern ~= self lastExecutedSearch
		ifTrue: [self searchPreferencesFor: self searchPattern].! !

!PreferenceBrowser methodsFor: 'stepping' stamp: 'hpt 8/27/2005 23:41'!
wantsStepsIn: aWindow
	^true.! !

!PreferenceBrowser methodsFor: 'user interface' stamp: 'rr 1/8/2006 12:35'!
windowTitle
	^ title translated! !

SystemWindow subclass: #PreferenceBrowserMorph
	instanceVariableNames: 'mainPanel defaultButton saveButton loadButton saveToDiskButton loadFromDiskButton themeButton helpButton preferenceList lastKeystrokeTime lastKeystrokes highlightedPreferenceButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PreferenceBrowser'!

!PreferenceBrowserMorph classSide methodsFor: 'instance creation' stamp: 'hpt 9/18/2004 15:31'!
withModel: aPreferenceBrowser
	^self new initializeWithModel: aPreferenceBrowser;
		yourself.! !

!PreferenceBrowserMorph methodsFor: 'updating' stamp: 'hpt 9/20/2004 23:31'!
adjustPreferenceListItemsWidth
	| panel |
	self preferenceList scroller submorphs 
		ifEmpty: [^self].
	panel := self preferenceListInnerPanel. 
	panel width: self preferenceList width - (self preferenceList scrollBarThickness*2).
	panel submorphsDo: [:ea | ea hResizing: #rigid; width: panel width].
	self preferenceList setScrollDeltas.! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 00:12'!
basicKeyPressed: anEvent
	| aChar oldSelection nextSelection max milliSeconds nextSelectionList nextSelectionPref |
	aChar := anEvent keyCharacter.
	nextSelection := oldSelection := self selectedPreferenceIndex.
	max := self selectedCategoryPreferences size.
	milliSeconds := Time millisecondClockValue.
	milliSeconds - lastKeystrokeTime > 300 ifTrue: ["just use the one current character for selecting"
		lastKeystrokes := ''].
	lastKeystrokes := lastKeystrokes , aChar asLowercase asString.
	lastKeystrokeTime := milliSeconds.
	nextSelectionList := OrderedCollection newFrom: (self selectedCategoryPreferences copyFrom: oldSelection + 1 to: max).
	nextSelectionList addAll: (self selectedCategoryPreferences copyFrom: 1 to: oldSelection).
	"Get rid of blanks and style used in some lists"
	nextSelectionPref := nextSelectionList detect: [:a | a name withBlanksTrimmed asLowercase beginsWith: lastKeystrokes]
				ifNone: [^ self preferenceList flash"match not found"].
	nextSelection := self selectedCategoryPreferences findFirst: [:a | a  = nextSelectionPref].
	"No change if model is locked"
	oldSelection == nextSelection ifTrue: [^ self preferenceList flash].
	^ self selectedPreferenceIndex: nextSelection! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'hpt 8/28/2005 00:04'!
buttonRowLayoutFrame 
	^LayoutFrame fractions: (0@0 corner: 1@0) offsets: (0@0 corner: 0@ (TextStyle defaultFont height * 2.5))! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'hpt 9/18/2004 16:55'!
defaultButton
	^defaultButton ifNil: 
		[defaultButton := self basicButton 
						label: 'default' translated; 
						actionSelector: #defaultSelected;						
						setBalloonText: 
							'Click here to reset all the preferences to their standard ',
							'default values.' translated]! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 00:16'!
downKeyPressed: anEvent
	self selectedPreferenceIndex:
		(self selectedPreferenceIndex + 1 
				min: self selectedCategoryPreferences size)! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 00:17'!
endKeyPressed: anEvent
	self selectedPreferenceIndex: self selectedCategoryPreferences size.
! !

!PreferenceBrowserMorph methodsFor: 'geometry' stamp: 'hpt 9/18/2004 21:05'!
extent: aPoint
	super extent: aPoint.
	self fullBounds.
	self adjustPreferenceListItemsWidth.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'hpt 9/18/2004 16:56'!
helpButton
	^helpButton ifNil: 
		[helpButton := self basicButton 
						label: 'help' translated; 
						setBalloonText: 
							'Click here to get some hints on use of this Preferences ',
							'Panel' translated;
						actionSelector: #helpSelected]! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 00:16'!
homeKeyPressed: anEvent
	self selectedPreferenceIndex: 1.
! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 00:19'!
keyPressed: anEvent
	self selectedCategory 
		ifNil: [^self].
	anEvent keyValue = 30
		ifTrue: [^self upKeyPressed: anEvent].
	anEvent keyValue = 31
		ifTrue: [^self downKeyPressed: anEvent].
	anEvent keyValue = 1 
		ifTrue: [^self homeKeyPressed: anEvent].
	anEvent keyValue = 4
		ifTrue: [^self endKeyPressed: anEvent].
	anEvent keyValue = 11
		ifTrue: [^self pageUpKeyPressed: anEvent].
	anEvent keyValue = 12
		ifTrue: [^self pageDownKeyPressed: anEvent].
	self basicKeyPressed: anEvent.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'hpt 9/18/2004 16:56'!
loadButton
	^loadButton ifNil: 
		[loadButton := self basicButton 
						label: 'load' translated; 
						actionSelector: #loadSelected;						
						setBalloonText: 
							'Click here to reset all the preferences to their values ',
							'in your Personal Preferences.' translated]! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'hpt 9/18/2004 16:56'!
loadFromDiskButton
	^loadFromDiskButton ifNil: 
		[loadFromDiskButton := self basicButton 
						label: 'load from disk' translated; 
						actionSelector: #loadFromDiskSelected;						
						setBalloonText: 
							'Click here to load all the preferences from ',
							'their saved values on disk.' translated]! !

!PreferenceBrowserMorph methodsFor: 'submorphs - main panel' stamp: 'hpt 9/19/2004 03:01'!
mainPanel
	^mainPanel ifNil: 
		[mainPanel := Morph new
			color: Color transparent;
			hResizing: #spaceFill;
			vResizing: #spaceFill;
			cellInset: 5;
			layoutPolicy: TableLayout new;
			listCentering: #topLeft;
			listDirection: #leftToRight;
			cellPositioning: #topLeft;
			clipSubmorphs: true;
			on: #mouseEnter send: #paneTransition: to: self;
			addMorphBack: self newCategoryListPanel;
			addMorphBack: self newPreferenceListPanel;
			yourself].! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/26/2004 23:01'!
mouseDownOn: aPreferenceView event: anEvent
	anEvent hand newKeyboardFocus: self preferenceList scroller.
	anEvent yellowButtonPressed
		ifTrue: [aPreferenceView offerPreferenceNameMenu: self model]! !

!PreferenceBrowserMorph methodsFor: 'submorphs - category list' stamp: 'hpt 9/18/2004 16:07'!
newCategoryList 
	^(PluggableListMorph
		on: self model
		list: #categoryList
		selected: #selectedCategoryIndex
		changeSelected: #selectedCategoryIndex:)
			color: Color white;
			borderInset;
			vResizing: #spaceFill;
			hResizing: #rigid;
			width: 150;
			yourself.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - category list' stamp: 'hpt 9/19/2004 02:29'!
newCategoryListPanelLabel 
	^StringMorph contents: 'Categories' translated.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'hpt 12/8/2004 17:20'!
newPreferenceButtonFor: aPreference 
	| button |
	button := PBPreferenceButtonMorph preference: aPreference model: self model.
	button 
		on: #mouseDown
		send: #value:
		to: 
			[:anEvent | 
			self
				selectedPreference: aPreference;
				mouseDownOn: button preferenceView event: anEvent].
	^button! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'hpt 12/8/2004 17:20'!
newPreferenceListInnerPanel
	| panel maxWidth totalHeight |
	panel := (Morph new)
				color: Color transparent;
				layoutPolicy: TableLayout new;
				listDirection: #topToBottom;
				cellPositioning: #topLeft;
				yourself.
	self selectedCategoryPreferences 
		do: [:aPref | panel addMorphBack: (self newPreferenceButtonFor: aPref)].
	panel submorphs size = 0 ifTrue: [^panel].
	maxWidth := (panel submorphs detectMax: [:m | m width]) width.
	panel width: maxWidth.
	totalHeight := (panel submorphs collect: [:ea | ea height]) inject: 0
				into: [:h :tot | h + tot].
	panel height: totalHeight.
	panel fullBounds.
	^panel! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'hpt 9/19/2004 02:29'!
newPreferenceListPanelLabel 
	^StringMorph contents: 'Preferences' translated.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - search panel' stamp: 'hpt 9/19/2004 02:55'!
newSearchButton
	^self basicButton
			label: 'search' translated; 
			actionSelector: #searchSelected;
			setBalloonText: 
				'Type what you want to search for here, then hit ',
				'the "Search" button, or else hit RETURN or ENTER' translated.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'hpt 9/18/2004 16:49'!
newTransparentFiller
	^Morph new
		color: Color transparent;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		yourself.! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 00:24'!
pageDownKeyPressed: anEvent
	self selectedPreferenceIndex: (self selectedPreferenceIndex + self preferencesShowing size min: self selectedCategoryPreferences size).
! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 00:30'!
pageUpKeyPressed: anEvent
	self selectedPreferenceIndex: (self selectedPreferenceIndex - self preferencesShowing size max: 1).
! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'hpt 9/18/2004 21:19'!
preferenceListInnerPanel
	^self preferenceList scroller submorphs first! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'hpt 9/19/2004 00:29'!
preferencesShowing
	| prefs |
	prefs := self preferenceListInnerPanel submorphs
					copyFrom: (self selectedPreferenceIndex max: 1)
					to: self selectedCategoryPreferences size.
	^prefs reject: [:ea | (ea top - prefs first top) > self preferenceList scroller height].! !

!PreferenceBrowserMorph methodsFor: 'submorphs - root panel' stamp: 'stephaneducasse 2/4/2006 20:39'!
rootPanelLayoutFrame 
	| frame |
	frame := self buttonRowLayoutFrame.
	^LayoutFrame fractions: (0@0 corner: 1@1) offsets: (0@(frame bottomOffset) corner: 0@0)! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'hpt 9/18/2004 16:56'!
saveButton
	^saveButton ifNil: 
		[saveButton := self basicButton 
						label: 'save' translated; 
						actionSelector: #saveSelected;						
						setBalloonText: 
							'Click here to save the current constellation of Preferences ',
							'settings as your personal defaults; you can get them all ',
							'reinstalled with a single gesture by clicking the "Restore ',
							'my Personal Preferences".' translated]! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'hpt 9/18/2004 16:56'!
saveToDiskButton
	^saveToDiskButton ifNil: 
		[saveToDiskButton := self basicButton 
						label: 'save to disk' translated; 
						actionSelector: #saveToDiskSelected;						
						setBalloonText: 
							'Click here to save the current constellation of Preferences ',
							'settings to a file; you can get them all reinstalled with a ', 
							'single gesture by clicking "Restore Settings From Disk".'
								 translated]! !

!PreferenceBrowserMorph methodsFor: 'model access' stamp: 'hpt 9/19/2004 00:05'!
selectedCategory
	^self model selectedCategory! !

!PreferenceBrowserMorph methodsFor: 'model access' stamp: 'hpt 9/19/2004 00:05'!
selectedCategoryIndex
	^self model selectedCategoryIndex! !

!PreferenceBrowserMorph methodsFor: 'model access' stamp: 'hpt 9/19/2004 00:05'!
selectedCategoryIndex: anIndex
	^self model selectedCategoryIndex: anIndex! !

!PreferenceBrowserMorph methodsFor: 'model access' stamp: 'hpt 9/19/2004 00:05'!
selectedCategoryPreferences
	^self model selectedCategoryPreferences! !

!PreferenceBrowserMorph methodsFor: 'model access' stamp: 'hpt 9/19/2004 00:05'!
selectedPreference
	^self model selectedPreference! !

!PreferenceBrowserMorph methodsFor: 'model access' stamp: 'hpt 9/19/2004 00:06'!
selectedPreference: aPreference
	^self model selectedPreference: aPreference! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'hpt 12/8/2004 15:50'!
selectedPreferenceButton
	^(self preferenceListInnerPanel submorphs at: self selectedPreferenceIndex)! !

!PreferenceBrowserMorph methodsFor: 'model access' stamp: 'hpt 9/19/2004 00:10'!
selectedPreferenceIndex
	^self model selectedPreferenceIndex! !

!PreferenceBrowserMorph methodsFor: 'model access' stamp: 'hpt 9/19/2004 00:10'!
selectedPreferenceIndex: anIndex
	^self model selectedPreferenceIndex: anIndex! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'hpt 12/8/2004 15:54'!
turnOffSelectedPreference
	highlightedPreferenceButton 
		ifNil: [^self].
	highlightedPreferenceButton highlightOff.
	highlightedPreferenceButton := nil.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'marcus.denker 11/10/2008 10:04'!
turnOnSelectedPreference
	highlightedPreferenceButton 
		ifNotNil: [:m | m highlightOff].
	highlightedPreferenceButton := self selectedPreferenceButton
		highlightOn;
		yourself.
	self preferenceList scrollToShow: highlightedPreferenceButton bounds.! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 00:16'!
upKeyPressed: anEvent
	self selectedPreferenceIndex: 
			(self selectedPreferenceIndex - 1 max: 1).
! !

!PreferenceBrowserMorph methodsFor: 'updating' stamp: 'hpt 9/18/2004 21:16'!
update: aSymbol
	super update: aSymbol.
	aSymbol == #selectedPreference
		ifTrue: [self updateSelectedPreference].
	aSymbol == #selectedCategoryIndex
		ifTrue: [self updateSelectedCategoryPreferences].! !

!PreferenceBrowserMorph methodsFor: 'updating' stamp: 'hpt 9/19/2004 00:08'!
updateSelectedPreference
	| index |
	self selectedCategory ifNotNil: [self turnOffSelectedPreference].
	index := self selectedPreferenceIndex.
	index = 0
		ifTrue: [^self].
	self turnOnSelectedPreference.! !

PreferenceView subclass: #PBPreferenceView
	instanceVariableNames: 'actions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PreferenceBrowser'!

!PBPreferenceView commentStamp: '<historical>' prior: 0!
I am just a refactor of all the common method of the PreferenceBrowser preference views!

PBPreferenceView subclass: #PBBooleanPreferenceView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PreferenceBrowser'!

!PBBooleanPreferenceView commentStamp: '<historical>' prior: 0!
I am responsible for building the visual representation of a preference that accepts true and false values. This view is aimed to be used inside a PreferenceBrowser panel.!

!PBBooleanPreferenceView classSide methodsFor: 'initialization' stamp: 'hpt 9/26/2004 15:47'!
initialize
	PreferenceViewRegistry ofBooleanPreferences register: self.
! !

!PBBooleanPreferenceView classSide methodsFor: 'initialization' stamp: 'hpt 9/26/2004 15:47'!
unload
	PreferenceViewRegistry ofBooleanPreferences unregister: self.! !

!PBBooleanPreferenceView methodsFor: 'user interface' stamp: 'hpt 9/26/2004 00:25'!
representativeButtonWithColor: aColor inPanel: aPreferencesPanel
	^self horizontalPanel
		layoutInset: 2;
		cellInset: 7;
		color: aColor;
		addMorphBack: (StringMorph contents: self preference name);
		addMorphBack: self horizontalFiller; 
		addMorphBack: self enabledButton;
		addMorphBack: self localToProjectButton;
		yourself.! !

PBPreferenceView subclass: #PBColorPreferenceView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PreferenceBrowser'!

!PBColorPreferenceView classSide methodsFor: 'initialization' stamp: 'hpt 12/6/2004 20:49'!
initialize
	PreferenceViewRegistry ofColorPreferences register: self.! !

!PBColorPreferenceView classSide methodsFor: 'initialization' stamp: 'hpt 12/6/2004 20:49'!
unload
	PreferenceViewRegistry ofColorPreferences unregister: self.! !

!PBColorPreferenceView methodsFor: 'user interface' stamp: 'hpt 12/6/2004 21:24'!
colorSwatch
	^UpdatingRectangleMorph new
		target: self preference;
		getSelector: #preferenceValue;
		putSelector: #preferenceValue:;
		extent: 22@22;
		setBalloonText: 'click here to change the color' translated;
		yourself.! !

!PBColorPreferenceView methodsFor: 'user interface' stamp: 'hpt 12/6/2004 21:12'!
representativeButtonWithColor: aColor inPanel: aPreferenceBrowser
	^self horizontalPanel
		layoutInset: 2;
		color: aColor;
		cellInset: 20;
		cellPositioning: #center;
		addMorphBack: (StringMorph contents: self preference name);
		addMorphBack: self horizontalFiller;
		addMorphBack: self colorSwatch;
		yourself! !

PBColorPreferenceView subclass: #PBWindowColorPreferenceView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PreferenceBrowser'!

!PBWindowColorPreferenceView classSide methodsFor: 'initialization' stamp: 'hpt 12/8/2004 18:40'!
initialize
	self viewRegistry register: self.! !

!PBWindowColorPreferenceView classSide methodsFor: 'initialization' stamp: 'hpt 12/8/2004 18:40'!
unload
	self viewRegistry unregister: self.! !

!PBWindowColorPreferenceView classSide methodsFor: 'initialization' stamp: 'hpt 12/8/2004 18:40'!
viewRegistry
	^(PreferenceViewRegistry registryOf: #windowColorPreferences)
		viewOrder: 6;
		yourself.! !

!PBWindowColorPreferenceView methodsFor: 'initialization' stamp: 'hpt 12/8/2004 18:38'!
initialize
	super initialize.
	self addActionTitled: 'Bright' target: Preferences selector: #installBrightWindowColors arguments: {} balloonText: 'Use standard bright colors for all windows' translated.
	self addActionTitled: 'Pastel' target: Preferences selector: #installPastelWindowColors arguments: {} balloonText: 'Use standard pastel colors for all windows' translated.	
	self addActionTitled: 'White' target: Preferences selector: #installUniformWindowColors arguments: {} balloonText: 'Use white backgrounds for all standard windows' translated.! !

PBPreferenceView subclass: #PBHaloThemePreferenceView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PreferenceBrowser'!

!PBHaloThemePreferenceView commentStamp: '<historical>' prior: 0!
I am responsible for building the button for the Halo Theme preference!

!PBHaloThemePreferenceView classSide methodsFor: 'initialization' stamp: 'hpt 9/26/2004 15:48'!
initialize
	PreferenceViewRegistry ofHaloThemePreferences register: self.! !

!PBHaloThemePreferenceView classSide methodsFor: 'initialization' stamp: 'hpt 9/26/2004 15:48'!
unload
	PreferenceViewRegistry ofHaloThemePreferences unregister: self.! !

!PBHaloThemePreferenceView methodsFor: 'user interface' stamp: 'md 12/18/2008 16:22'!
haloThemeRadioButtons
	"Answer a column of butons representing the choices of halo theme"

	| buttonColumn aRow aRadioButton aLabel |
	buttonColumn := self verticalPanel.
	#(	(iconicHaloSpecifications iconic iconicHalosInForce	'circular halos with icons inside')
		(classicHaloSpecs	classic	classicHalosInForce		'plain circular halos')
		(customHaloSpecs	custom	customHalosInForce		'customizable halos')) do:

		[:quad |
			aRadioButton := UpdatingThreePhaseButtonMorph radioButton
				target: Preferences;
				setBalloonText: quad fourth;
				actionSelector: #installHaloTheme:;
				getSelector: quad third;
				arguments: (Array with: quad first);
				yourself.
			aLabel := (StringMorph contents: quad second asString)
						setBalloonText: quad fourth;
						yourself.
			aRow := self horizontalPanel
				cellInset: 4;
				addMorphBack: aRadioButton;
				addMorphBack: aLabel.
			buttonColumn addMorphBack: aRow].
	^ buttonColumn

	"(Preferences preferenceAt: #haloTheme) view tearOffButton"! !

!PBHaloThemePreferenceView methodsFor: 'initialization' stamp: 'alain.plantec 5/28/2009 10:13'!
initialize
	super initialize.
	self addActionTitled: 'edit custom halos' 
		target: Preferences 
		selector:  #editCustomHalos 
		arguments: {} 
		balloonText: 'Click here to edit the method that defines the custom halos' translated.! !

!PBHaloThemePreferenceView methodsFor: 'user interface' stamp: 'hpt 9/26/2004 00:45'!
representativeButtonWithColor: aColor inPanel: aPreferencesPanel
	| innerPanel |
	innerPanel := self horizontalPanel
		addMorphBack: (self blankSpaceOf: 10@0);
		addMorphBack: self haloThemeRadioButtons;
		yourself.
	^self verticalPanel
		color: aColor;
		layoutInset: 2;
		addMorphBack: (StringMorph contents: self preference name);
		addMorphBack: innerPanel.! !

PBPreferenceView subclass: #PBNumericPreferenceView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PreferenceBrowser'!

!PBNumericPreferenceView classSide methodsFor: 'initialization' stamp: 'hpt 12/9/2004 22:21'!
initialize
	PreferenceViewRegistry ofNumericPreferences register: self.! !

!PBNumericPreferenceView classSide methodsFor: 'initialization' stamp: 'hpt 12/9/2004 22:21'!
unload
	PreferenceViewRegistry ofNumericPreferences unregister: self.! !

!PBNumericPreferenceView methodsFor: 'user interface' stamp: 'hpt 12/9/2004 22:23'!
preferenceValue
	^self preference preferenceValue asString! !

!PBNumericPreferenceView methodsFor: 'user interface' stamp: 'hpt 12/10/2004 22:53'!
preferenceValue: aTextOrString
	(aTextOrString notEmpty and: [aTextOrString asString isAllDigits])
		ifFalse: [^false].
	self preference preferenceValue: aTextOrString asNumber.
	^true.! !

!PBNumericPreferenceView methodsFor: 'user interface' stamp: 'hpt 12/9/2004 22:19'!
representativeButtonWithColor: aColor inPanel: aPreferenceBrowser
	^self horizontalPanel
		layoutInset: 2;
		color: aColor;
		cellInset: 20;
		cellPositioning: #center;
		addMorphBack: (StringMorph contents: self preference name);
		addMorphBack: self textField;
		yourself.! !

!PBPreferenceView classSide methodsFor: 'view registry' stamp: 'hpt 9/26/2004 16:09'!
handlesPanel: aPreferencePanel
	^aPreferencePanel isKindOf: PreferenceBrowser! !

!PBPreferenceView methodsFor: 'actions' stamp: 'stephaneducasse 2/4/2006 20:39'!
actions
	^actions ifNil: [actions := OrderedCollection new.]! !

!PBPreferenceView methodsFor: 'actions' stamp: 'hpt 12/8/2004 18:13'!
addActionTitled: aTitle target: aTarget selector: aSelector arguments: aCollection balloonText: aText
	self actions add: { aTitle. aTarget. aSelector. aCollection. aText }! !

!PBPreferenceView methodsFor: 'user interface' stamp: 'hpt 9/26/2004 11:42'!
basicPanel
	^BorderedMorph new
		beTransparent;
		extent: 0@0;
		borderWidth: 0;
		layoutInset: 0;
		cellInset: 2;
		layoutPolicy: TableLayout new;
		listCentering: #topLeft;
		cellPositioning: #center;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		yourself! !

!PBPreferenceView methodsFor: 'user interface' stamp: 'hpt 9/26/2004 00:15'!
blankSpaceOf: aPoint
	^Morph new 
		beTransparent;
		extent: aPoint; 
		yourself! !

!PBPreferenceView methodsFor: 'user interface' stamp: 'hpt 9/26/2004 00:13'!
horizontalFiller
	^self horizontalPanel
		hResizing: #spaceFill;
		yourself.! !

!PBPreferenceView methodsFor: 'user interface' stamp: 'hpt 9/26/2004 11:43'!
horizontalPanel
	^self basicPanel
		cellPositioning: #center;
		listDirection: #leftToRight;
		yourself.! !

!PBPreferenceView methodsFor: 'user interface' stamp: 'alain.plantec 5/30/2008 14:00'!
offerPreferenceNameMenu: aPreferenceBrowser
	"the user clicked on a preference name -- put up a menu"

	| aMenu |			
	aMenu := MenuMorph new 
		defaultTarget: self preference;
		addTitle: self preference name.

	(Preferences okayToChangeProjectLocalnessOf: self preference name) ifTrue:
		[aMenu addUpdating: #isProjectLocalString target: self preference action: #toggleProjectLocalness.
		aMenu balloonTextForLastItem: 'Some preferences are best applied uniformly to all projects, and others are best set by each individual project.  If this item is checked, then this preference will be printed in bold and will have a separate value for each project'].

	aMenu add: 'browse senders' translated target: self systemNavigation selector: #browseAllCallsOn: argument: self preference name.
	aMenu balloonTextForLastItem: 'This will open a method-list browser on all methods that the send the preference "', self preference name, '".'. 
	aMenu add: 'show category...' target: aPreferenceBrowser selector: #findCategoryFromPreference: argument: self preference name.
	aMenu balloonTextForLastItem: 'Allows you to find out which category, or categories, this preference belongs to.'.

	aMenu add: 'hand me a button for this preference' target: self selector: #tearOffButton.
	aMenu balloonTextForLastItem: 'Will give you a button that governs this preference, which you may deposit wherever you wish'.

	aMenu add: 'copy this name to clipboard' target: self preference selector: #copyName.
	aMenu balloonTextForLastItem: 'Copy the name of the preference to the text clipboard, so that you can paste into code somewhere'.

	aMenu popUpInWorld! !

!PBPreferenceView methodsFor: 'user interface' stamp: 'hpt 9/26/2004 11:43'!
verticalPanel
	^self basicPanel
		cellPositioning: #topLeft;
		listDirection: #topToBottom;
		yourself.! !

PBPreferenceView subclass: #PBTextPreferenceView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PreferenceBrowser'!

!PBTextPreferenceView classSide methodsFor: 'initialization' stamp: 'hpt 9/26/2004 17:01'!
initialize
	PreferenceViewRegistry ofTextPreferences register: self.! !

!PBTextPreferenceView classSide methodsFor: 'initialization' stamp: 'hpt 9/26/2004 17:01'!
unload
	PreferenceViewRegistry ofTextPreferences unregister: self.! !

!PBTextPreferenceView methodsFor: 'user interface' stamp: 'hpt 12/10/2004 22:46'!
preferenceValue
	^self preference preferenceValue ifNil: ['']! !

!PBTextPreferenceView methodsFor: 'user interface' stamp: 'hpt 9/26/2004 11:38'!
preferenceValue: aTextOrString
	self preference preferenceValue: aTextOrString asString.
	^true.! !

!PBTextPreferenceView methodsFor: 'user interface' stamp: 'hpt 9/26/2004 11:41'!
representativeButtonWithColor: aColor inPanel: aPreferenceBrowser
	^self horizontalPanel
		layoutInset: 2;
		color: aColor;
		cellInset: 20;
		cellPositioning: #center;
		addMorphBack: (StringMorph contents: self preference name);
		addMorphBack: self textField;
		yourself.! !
PBBooleanPreferenceView initialize!
PBColorPreferenceView initialize!
PBHaloThemePreferenceView initialize!
PBNumericPreferenceView initialize!
PBTextPreferenceView initialize!
PBWindowColorPreferenceView initialize!
PreferenceBrowser initialize!
